/*
 *  server_ip is the IP address of the ESP8266 module, will be 
 *  printed to Serial when the module is connected.
 */

#include <ESP8266WiFi.h>
#include <Wire.h>
#include <Adafruit_PWMServoDriver.h>

// called this way, it uses the default address 0x40
Adafruit_PWMServoDriver pwm = Adafruit_PWMServoDriver();
// you can also call it with a different address you want
//Adafruit_PWMServoDriver pwm = Adafruit_PWMServoDriver(0x41);

// Depending on your servo make, the pulse width min and max may vary, you 
// want these to be as small/large as possible without hitting the hard stop
// for max range. You'll have to tweak them as necessary to match the servos you
// have!
#define SERVOMIN  150 // this is the 'minimum' pulse length count (out of 4096)
#define SERVOMAX  550 // this is the 'maximum' pulse length count (out of 4096)
// our servo # counter
uint8_t servonum = 0;

const char* ssid = "Z21_6666";
const char* password = "54448049";

// Create an instance of the server
// specify the port to listen on as an argument 80
WiFiServer server(4711);

boolean alreadyConnected = false; // whether or not the client was connected previously
//-----------------------------------------------------------------------------------------------
// Управляющие пины:
// #define WIRE1_PIN  4  // D2
// #define WIRE2_PIN  5  // D1
// #define WIRE3_PIN  14 // D5 занят
// #define WIRE4_PIN  12 // D6
// #define WIRE5_PIN  13 // D7

// FB part:
//--------------------------------------------------------------------------------------------
// boolean flag0 = false;    // метка о том, что препятствие уже посчитали
// byte last_data = 0; 
// byte data = 0;            // выходное значение

// Обработчик стрелочных пакетов. Эта функция запускается, когда библиотека ловит пакет:
void switchSend(byte address, byte data)
{
 Serial.print("Z , ");
 Serial.print(address);
 Serial.print(", ");
 Serial.println(data);
// Адресация по id. Переключение по первой букве cmd.
// Обрабатываем адрес стрелки:
 servonum = (address - 20); // адреса стрелок с 20 до 35

 if (data == 0x73) { // s = 115 = 0x73
  for (uint16_t pulselen = SERVOMAX; pulselen > SERVOMIN; pulselen--) {
   pwm.setPWM(servonum, 0, pulselen);
   delay(30);
  }
 }
 if (data == 0x74) { // t = 116 = 0x74
  for (uint16_t pulselen = SERVOMIN; pulselen < SERVOMAX; pulselen++) {
   pwm.setPWM(servonum, 0, pulselen);
   delay(30);
  }
 }
}// end of handler

void setup() {
  Serial.begin(115200);
  delay(10);

  Wire.pins(2, 14);   // ESP8266 can use any two pins, such as SDA to #2 and SCL to #14
 
  pwm.begin();
  
  pwm.setPWMFreq(60);  // Analog servos run at ~60 Hz updates

  yield();

  // Connect to WiFi network
  Serial.println();
  Serial.println();
  Serial.print("Connecting to ");
  Serial.println(ssid);
  
  WiFi.begin(ssid, password);
  
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  Serial.println("");
  Serial.println("WiFi connected");
  
  // Start the server
  server.begin();
  Serial.println("Server started");

  // Print the IP address
  Serial.println(WiFi.localIP());

//Выставляем управляющие пины на вывод:
// pinMode(WIRE1_PIN, OUTPUT);
//Выставляем их:
// digitalWrite(WIRE1_PIN, LOW);
}

void loop() {
  // Check if a client has connected
  WiFiClient client = server.available();
  if (!client) {
    return;
  }
 
  Serial.println("new client");

// Wait until the client sends some data
  while(!client.available()){

// датчик 0
//  if ((!digitalRead(13)) && (flag0 == false)){    // сравниваем. Если меньше И препятствие еще не зафиксировано
//     data = (data + 1);                          // 
//     flag0 = true;                               // ставим метку, что препятствие посчитано
//     }
//  if ((digitalRead(13)) && (flag0 == true)){     // опять сравниваем. Если больше И препятствие уже было зафиксировано
//     data = (data - 1);
//     flag0 = false;                              // сбрасываем метку, т.е. следующее препятствие будет снова посчитано
//     }

//  if (data != last_data){    //Если состояние входа изменилось, расскажем
//    if (data == 1){ 
//      client.println("<fb id=\"fb-5\" state=\"true\" fbtype=\"0\"/>");
//    } else { 
//      client.println("<fb id=\"fb-5\" state=\"false\" fbtype=\"0\"/>");
//    }
//   last_data = data; // запоминаем текущие состояния
//   }

    delay(1);
  }

  //--- chtenie stroki
 String req = client.readStringUntil('/');

 client.stop();
 Serial.println("client disonnected");
    
 // Serial.println(req);
 // Serial.println(req[8]);
 // Serial.println(req[9]);

//--- obrabotka
/*
Адресация по id. Переключение по первой букве cmd.
          1         2
012345678901234567890
<sw id="sw-20" cmd="turnout" manualcmd="true" controlcode="" slavecode="" server="infw01178B8C" iid="LAN" prot="D" uidname="" bus="0" addr1="29" port1="0" gate1="0" param1="0" value1="0" delay="0" actdelay="false" singlegate="false" accessory="true" porttype="0" decid="DEC-1"/>
*/
 if ((req[8] == 115) && (req[9] == 119)){ // s = 115 w = 119
 byte address = ((req[11]-48)*10)+(req[12]-48);
 byte data = req[20];
 switchSend( address, data);
 }

} //END loop

//End of sketch

